package com.example.astronomy

import javax.swing.*

fun main() = SwingUtilities.invokeLater {
  val window = createImageViewerWindow()

  try {
    loadImage(window)
  } catch (error: Throwable) {
    window.add(JLabel("Sorry, something went wrong"), JLabel.CENTER)
  }
}

fun loadImage(window: JFrame) {
  val infoRequest = astronomyService.getPictures(count = 1, apiKey)
  val infoResponse = infoRequest.execute()
  val imageUrl = infoResponse.body()!!.single().url
  val imageRequest = astronomyService.downloadImage(imageUrl)
  val imageResponse = imageRequest.execute()

  window.displayImage(imageResponse.body()!!.bytes())
}
