package com.example.astronomy

import javax.swing.*
import retrofit2.*

class ImageGallery : ImageViewer() {
  override suspend fun update(window: JFrame) {
    val infoRequest = astronomyService.getPictures(count = 2, apiKey)
    val (info1, info2) = infoRequest.awaitResponse().body()!!

    val image1 = downloadImage(info1.url)
    val image2 = downloadImage(info2.url)

    displayImageGallery(window, listOf(image1, image2))
  }

  private suspend fun downloadImage(url: String): ByteArray =
    astronomyService.downloadImage(url).awaitResponse().body()!!.bytes()
}

fun main() = createWindow("Image Viewer", ImageGallery())
