package com.example.astronomy

import javax.swing.*
import retrofit2.*

suspend fun getImages(count: Int): List<ByteArray> {
  val infoRequest = astronomyService.getPictures(count, apiKey)
  val imageInfo = infoRequest.awaitResponse().body()!!

  return imageInfo.map { downloadImage(it.url) }
}

private suspend fun downloadImage(url: String): ByteArray =
  astronomyService.downloadImage(url).awaitResponse().body()!!.bytes()

fun main() = createWindow("Image Viewer", object : ImageViewer() {
  override suspend fun update(window: JFrame) {
    val images = getImages(6)
    displayImageGallery(window, images)
  }
})
