package com.example.astronomy

import java.awt.*
import java.awt.event.*
import javax.swing.*

fun createWindow(title: String, listener: WindowListener) {
  SwingUtilities.invokeLater {
    val window = JFrame(title)
    window.defaultCloseOperation = JFrame.DISPOSE_ON_CLOSE
    window.size = Dimension(400, 300)
    window.addWindowListener(listener)
    window.isVisible = true
  }
}

fun displayImageGallery(window: JFrame, images: List<ByteArray>) {
  val panel = JPanel(GridLayout(0, 1))

  for (image in images) {
    panel.add(JLabel(ImageIcon(image)))
  }

  window.contentPane.removeAll()
  window.add(JScrollPane(panel))
  window.pack()
}
