package com.example.astronomy

import javax.swing.*
import kotlinx.coroutines.*
import retrofit2.*

suspend fun main(): Unit = withContext(Dispatchers.Main) {
  val window = createImageViewerWindow()

  try {
    loadImage(window)
  } catch (error: Throwable) {
    window.add(JLabel("Sorry, something went wrong"), JLabel.CENTER)
  }
}

suspend fun loadImage(window: JFrame) {
  val infoRequest = astronomyService.getPictures(count = 1, apiKey)
  val infoResponse = infoRequest.awaitResponse()
  val imageUrl = infoResponse.body()!!.single().url
  val imageRequest = astronomyService.downloadImage(imageUrl)
  val imageResponse = imageRequest.awaitResponse()

  window.displayImage(imageResponse.body()!!.bytes())
}
