package com.example.astronomy

import java.awt.event.*
import javax.swing.*
import retrofit2.*

class ImageViewer : WindowAdapter() {
  override suspend fun windowOpened(e: WindowEvent) { // error!
    val window = e.window as JFrame
    window.add(JLabel("Loading your image…", JLabel.CENTER))
    loadImage(window)
  }
}

fun main() = createWindow("Image Viewer", ImageViewer())

suspend fun loadImage(window: JFrame) {
  val infoRequest = astronomyService.getPictures(count = 1, apiKey)
  val infoResponse = infoRequest.awaitResponse()

  val imageUrl = infoResponse.body()!!.single().url
  val imageRequest = astronomyService.downloadImage(imageUrl)
  val imageResponse = imageRequest.awaitResponse()

  window.displayImage(imageResponse.body()!!.bytes())
}
