package com.example.channels

import kotlinx.coroutines.*
import kotlinx.coroutines.channels.*

suspend fun main() = coroutineScope {
  val channel = Channel<Char>()

  launch { // sender
    for (outgoingChar in "Hi!") {
      println("Sending '$outgoingChar'…")
      channel.send(outgoingChar)
      delay(100)
    }
  }

  repeat(3) { // receiver
    val incomingChar = channel.receive()
    println("Received '$incomingChar'")
  }
}
