package com.example.channels

import kotlinx.coroutines.*
import kotlinx.coroutines.channels.*

suspend fun main() = coroutineScope {
  val channel = Channel<Char>()

  for (name in listOf('A', 'B')) launch { // receiver x2
    for (message in channel) {
      println("Consumer $name received '$message'")
    }
  }

  for (outgoingChar in "Hi!") { // sender
    println("Sending '$outgoingChar'…")
    channel.send(outgoingChar)
    delay(100)
  }
  channel.close()
  println("Done!")
}
