package com.example.channels

import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*

suspend fun main() = coroutineScope {
  val flow = MutableSharedFlow<Char>()

  val receiver = launch {
    for (name in listOf('A', 'B')) launch { // receiver x2
      flow.collect { message ->
        println("Consumer $name received '$message'")
      }
    }
  }

  for (outgoingChar in "Hi!") { // sender
    println("Sending '$outgoingChar'…")
    flow.emit(outgoingChar)
    delay(100)
  }
  receiver.cancel()
  println("Done!")
}
