package com.example.coffee

import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*

suspend fun main() = coroutineScope {
  val coffeeJob: Job = launch {
    makeCoffee()
  }

  println("isActive: " + coffeeJob.isActive)
  println("Waiting for six seconds…")
  delay(6.seconds)
  println("isActive: " + coffeeJob.isActive)
}

suspend fun makeCoffee() {
  println("Brewing your coffee…")
  delay(5.seconds)
  println("Coffee's ready!")
}
