package com.example.coffee

import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*

suspend fun main() = coroutineScope {
  val coffeeJob: Job = launch {
    launch {
      val beans = grindBeans()
      println("Prepared some $beans")
    }

    launch {
      val water = heatWater()
      println("Prepared some $water")
    }

    // TODO: finish making the coffee
    println("Done launching two child jobs!")
  }

  while (coffeeJob.isActive) {
    println("coffeeJob.isActive is: ${coffeeJob.isActive}")
    delay(2.seconds)
  }
  println("coffeeJob.isActive is: ${coffeeJob.isActive}")
}

suspend fun grindBeans(): String {
  delay(5.seconds)
  return "freshly ground coffee"
}

suspend fun heatWater(): String {
  delay(5.seconds)
  return "piping hot water"
}
