package com.example.coffee

import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*

suspend fun main() {
  coroutineScope {
    try {
      launch { grindBeans() }
      launch { heatWater() }
      launch { frothMilk() }
    } catch (error: OutOfMilkException) {
      println("Your coffee is important to us! Please try again later.")
    }
  }
}

suspend fun frothMilk(): String = throw OutOfMilkException()

class OutOfMilkException() : RuntimeException("There's no milk!")

suspend fun grindBeans(): String {
  delay(5.seconds)
  return "freshly ground coffee"
}

suspend fun heatWater(): String {
  delay(5.seconds)
  return "piping hot water"
}
