package com.example.coffee

import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*

suspend fun main() {
  coroutineScope {
    launch {
      while (true) {
        delay(2.seconds)
        println("Making another cup of coffee…")
      }
    }

    launch {
      delay(10.seconds)
      throw RuntimeException("Sorry, it's closing time!")
    }
  }
}

suspend fun frothMilk(): String = throw OutOfMilkException()

class OutOfMilkException() : RuntimeException("There's no milk!")

suspend fun grindBeans(): String {
  delay(5.seconds)
  return "freshly ground coffee"
}

suspend fun heatWater(): String {
  delay(5.seconds)
  return "piping hot water"
}
