package com.example.gallery

import java.awt.*
import java.io.*
import java.util.concurrent.*
import javax.imageio.*
import kotlinx.coroutines.*
import kotlinx.coroutines.future.*

suspend fun readImage(file: File): Image =
  withContext(Dispatchers.IO) {
    ImageIO.read(file)
  }

suspend fun getImageFromFile(): Image = withContext(Dispatchers.Main) {
  val file = promptForFile() ?: error("No file selected")
  readImage(file)
}

fun CoroutineScope.getImageFromFileAsync(): CompletableFuture<Image> {
  val imageTask = async { getImageFromFile() }
  return imageTask.asCompletableFuture()
}
