package com.example.gallery

import java.awt.*
import java.awt.event.*
import java.io.*
import javax.imageio.*
import javax.swing.*
import kotlinx.coroutines.*

fun createWindow(title: String, listener: WindowListener) {
  SwingUtilities.invokeLater {
    val window = JFrame(title)
    window.defaultCloseOperation = JFrame.DISPOSE_ON_CLOSE
    window.size = Dimension(400, 300)
    window.addWindowListener(listener)
    window.isVisible = true
  }
}

fun displayImage(window: JFrame, image: Image) {
  window.contentPane.removeAll()
  window.add(JLabel(ImageIcon(image)))
  window.pack()
}

fun promptForFile(context: JFrame? = null): File? {
  val dialog = FileDialog(context)
  dialog.isVisible = true
  return dialog.files.singleOrNull()
}
