package com.example.gallery

import java.awt.*
import java.util.concurrent.*
import javax.swing.*
import kotlinx.coroutines.*
import kotlinx.coroutines.future.*

class FutureImageViewer(val image: CompletableFuture<Image>) : ImageViewer() {
  override suspend fun update(window: JFrame) {
    displayImage(window, image.await())
  }
}

suspend fun main() = coroutineScope {
  val image = getImageFromFileAsync()
  createWindow("Image Viewer", FutureImageViewer(image))
}
