package com.example.gallery

import java.awt.*
import javax.imageio.*
import javax.swing.*

fun main() = createWindow("Image Viewer", object : ImageViewer() {
  override suspend fun update(window: JFrame) {
    val file = promptForFile(window) ?: return

    val worker = object : SwingWorker<Image, Nothing>() {
      override fun doInBackground() = ImageIO.read(file)
      override fun done() = displayImage(window, get())
    }

    worker.execute()
  }
})
