package com.example.gallery

import java.awt.*
import java.io.*
import javax.imageio.*
import javax.swing.*
import kotlinx.coroutines.*

fun main() = createWindow("Image Viewer", object : ImageViewer() {
  override suspend fun update(window: JFrame) {
    val file = promptForFile(window) ?: return
    val image = readImage(file)
    displayImage(window, image)
  }
})

suspend fun readImage(file: File): Image =
  withContext(Dispatchers.IO) {
    ImageIO.read(file)
  }
