package com.example.gallery

import java.awt.*
import java.awt.image.*
import javax.swing.*

fun main() = createWindow("Image Viewer", object : ImageViewer() {
  override suspend fun update(window: JFrame) {
    val image = generateImage()
    displayImage(window, image)
  }
})

fun generateImage(): Image {
  val image = BufferedImage(10240, 7680, BufferedImage.TYPE_INT_RGB)
  for (x in 0 until image.width) for (y in 0 until image.height) {
    val hue = (x + y).toFloat() / ((image.width - 1) + (image.height - 1))
    image.setRGB(x, y, Color.HSBtoRGB(hue, 1f, 1f))
  }
  return image.getScaledInstance(1024, 768, Image.SCALE_SMOOTH)
}
