package com.example.gallery

import kotlinx.coroutines.*
import java.awt.event.*
import javax.swing.*

abstract class ImageViewer : WindowAdapter() {
  val coroutineScope = MainScope()

  override fun windowOpened(e: WindowEvent) {
    val window = e.window as JFrame
    window.add(JLabel("Loading your image…", JLabel.CENTER))
    coroutineScope.launch {
      update(window)
    }
  }

  protected abstract suspend fun update(window: JFrame)

  override fun windowClosed(e: WindowEvent) {
    coroutineScope.cancel()
  }
}
