package com.example.parallel

import kotlin.time.*

val chars = ('a'..'z') + ('A'..'Z') + ('0'..'9') + '_' + '!' + '?'

val passwords = List(2_000) {
  CharArray(10) { chars.random() }.concatToString()
}

fun main() {
  val (values, duration) = measureTimedValue {
    passwords.map { hash(it) }
  }

  println("Computed ${values.size} hashes in $duration")
}
