package com.example.parallel

import kotlin.time.*
import kotlinx.coroutines.*

val chars = ('a'..'z') + ('A'..'Z') + ('0'..'9') + '_' + '!' + '?'

val passwords = List(2_000) {
  CharArray(10) { chars.random() }.concatToString()
}

suspend fun main() = withContext(Dispatchers.Default) {
  val (values, duration) = measureTimedValue {
    val results = passwords.map {
      async { hash(it) }
    }
    results.awaitAll()
  }

  println("Computed ${values.size} hashes in $duration")
}
