package com.example.parallel

import kotlin.time.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*

val chars = ('a'..'z') + ('A'..'Z') + ('0'..'9') + '_' + '!' + '?'

val passwords = List(2_000) {
  CharArray(10) { chars.random() }.concatToString()
}

suspend fun main() {
  val (value, duration) = measureTimedValue {
    withTimeoutOrNull(5.seconds) {
      slowHash("kotlin1")
    }
  }

  println("Computed the hash in $duration")
  println(value)
}
