package com.example.pets

import javax.imageio.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*
import retrofit2.*

val breeds = flow {
  var i = 0
  while (true) { // (1)
    val page = petService.listBreeds(limit = 5, page = i++).await()
    if (page.isNotEmpty()) for (item in page) emit(item) else break // (2)
  }
}

suspend fun main() {
  breeds.collect { breed ->
    val info = petService.getImageInfo(breed.reference_image_id)
    val imageResponse = petService.downloadImage(info.url)
    val image = ImageIO.read(imageResponse.byteStream())

    // TODO: do something with the image

    delay(5.seconds)
  }
}
