package com.example.pets

import java.awt.*
import java.net.*
import java.net.http.*
import java.net.http.HttpResponse.*
import java.util.concurrent.*
import javax.imageio.*

val client = HttpClient.newHttpClient()

fun downloadAsync(url: String): CompletableFuture<HttpResponse<ByteArray>> {
  val request = HttpRequest.newBuilder(URI(url)).build()
  return client.sendAsync(request, BodyHandlers.ofByteArray())
}

fun downloadImageAsync(url: String): CompletableFuture<Image> =
  downloadAsync(url)
    .thenApply { it.body().inputStream() }
    .thenApply { ImageIO.read(it) }
