package com.example.pets

import javax.imageio.*
import javax.swing.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*
import retrofit2.*

val breeds = flow {
  var i = 0
  while (true) { // (1)
    val page = petService.listBreeds(limit = 5, page = i++).await()
    if (page.isNotEmpty()) for (item in page) emit(item) else break // (2)
  }
}

suspend fun main() = createWindow("Slideshow") { window ->
  breeds.collect { // (3)
    val imageInfo = petService.getImageInfo(it.reference_image_id)
    val imageResponse = petService.downloadImage(imageInfo.url) // (4)
    val image = ImageIO.read(imageResponse.byteStream())

    window.contentPane.removeAll()
    window.add(JLabel(ImageIcon(image))) // (5)
    window.pack()

    delay(5.seconds)
  }
}
