package com.example.pets

import java.awt.*
import javax.imageio.*
import javax.swing.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*
import retrofit2.*

val breeds = flow {
  var i = 0
  while (true) { // (1)
    val page = petService.listBreeds(limit = 5, page = i++).await()
    if (page.isNotEmpty()) for (item in page) emit(item) else break // (2)
  }
}

val images: Flow<Image> = breeds.map {
  val info = petService.getImageInfo(it.reference_image_id)
  val imageResponse = petService.downloadImage(info.url)
  ImageIO.read(imageResponse.byteStream())
}

suspend fun main() = createWindow("Slideshow") { window ->
  images.collect { image ->
    window.contentPane.removeAll()
    window.add(JLabel(ImageIcon(image)))
    window.pack()

    delay(5.seconds)
  }
}
