package com.example.testing

import kotlin.coroutines.*
import kotlinx.coroutines.*

class DataProviderActivity<T>(
  private val provider: DataProvider<T>,
  private val observer: Observer,
  coroutineContext: CoroutineContext = EmptyCoroutineContext
) : Activity {
  private val activityScope = MainScope() + coroutineContext

  override fun onCreate() {
    activityScope.launch {
      provider.withObserver(observer).fetchOrDefault(null)
    }
  }

  override fun onDestroy() = activityScope.cancel()
}
