package com.example.testing

import kotlin.test.*
import kotlinx.coroutines.test.*

class DataProviderTest {
  @Test
  fun useDefaultValueWhenOffline() = runTest {
    isOffline = true
    val provider = DataProvider { fail("Should not be called") }
    val data = provider.fetchOrDefault("Default value")

    assertEquals("Default value", data)
  }

  @Test
  fun useProvidedValueWhenOnline() = runTest {
    isOffline = false
    val provider = DataProvider { "Provided value" }
    val data = provider.fetchOrDefault("Default value")

    assertEquals("Provided value", data)
  }
}
