package com.example.testing

import kotlin.test.*

class DataProviderTest {
  @Test
  fun useDefaultValueWhenOffline() {
    isOffline = true
    val provider = DataProvider { fail("Should not be called") }
    val data = provider.fetchOrDefault("Default value") // error!

    assertEquals("Default value", data)
  }

  @Test
  fun useProvidedValueWhenOnline() {
    isOffline = false
    val provider = DataProvider { "Provided value" }
    val data = provider.fetchOrDefault("Default value") // error!

    assertEquals("Provided value", data)
  }
}
