package com.example.testing

import app.cash.turbine.*
import com.example.testing.Observer.Event.*
import com.example.testing.Observer.Event
import kotlin.test.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*
import kotlinx.coroutines.test.*

class DataProviderEventsTest {
  @Test
  fun publishDownloadEvents() = runTest {
    val turbine = Turbine<Event>()

    launch {
      DataProvider { delay(2.seconds) }
        .withObserver { event -> turbine.add(event) }
        .fetchOrDefault(null)
    }

    delay(1.seconds)
    assertEquals(DownloadStarted, turbine.expectMostRecentItem())
    turbine.expectNoEvents()
    delay(1.seconds)
    assertEquals(DownloadComplete, turbine.expectMostRecentItem())
  }
}
