package com.example.testing

import kotlinx.coroutines.*

class DataProviderActivity<T>(
  private val provider: DataProvider<T>,
  private val observer: Observer
) : Activity {
  private val activityScope = MainScope()

  override fun onCreate() {
    activityScope.launch {
      provider.withObserver(observer).fetchOrDefault(null)
    }
  }

  override fun onDestroy() = activityScope.cancel()
}
