package com.example.testing

import app.cash.turbine.*
import com.example.testing.Observer.Event
import com.example.testing.Observer.Event.*
import kotlin.test.*
import kotlin.time.Duration.Companion.seconds
import kotlinx.coroutines.*
import kotlinx.coroutines.test.*
import org.junit.Test

class DataProviderActivityTest {
  @Test
  fun publishDownloadEvents() = runTest {
    val turbine = Turbine<Event>()

    val provider = DataProvider { delay(2.seconds) }
    val observer = Observer { event -> turbine.add(event) }
    DataProviderActivity(provider, observer).onCreate()

    delay(1.seconds)
    assertEquals(DownloadStarted, turbine.expectMostRecentItem())
    turbine.expectNoEvents()
    delay(1.seconds)
    assertEquals(DownloadComplete, turbine.expectMostRecentItem())
  }
}
