package com.example.timers

import kotlin.concurrent.*
import kotlin.coroutines.*

val timer = java.util.Timer()

suspend fun main() {
  println("1. Coroutine is running")

  val result = suspendCoroutine { continuation ->
    println("2. Suspending the coroutine for 5 seconds")

    timer.schedule(5000) { // enqueue callback for later execution
      println("4. Time's up: resuming the coroutine")
      continuation.resume("Hello!")
      timer.cancel()
    }

    println("3. Now, we wait…")
  }

  println("5. Coroutine resumed with result: $result")
}
