package com.example.todo

import java.io.*

val hype = listOf("You got this!", "Crush it!", "Let's go!", "Easy!")

fun getTaskList(): InputStream =
  ClassLoader.getSystemResourceAsStream("todo.txt") ?: error("Not found")

val tasks = sequence {
  val reader = getTaskList().bufferedReader()
  try {
    while (true) {
      val task = reader.readLine()
      if (task != null) yield(task) else break
    }
  } finally {
    reader.close()
  }
}

fun main() {
  for (task in tasks) {
    println("$task. " + hype.random())
  }
}
