package com.example.todo

import java.io.*
import kotlinx.coroutines.*

val hype = listOf("You got this!", "Crush it!", "Let's go!", "Easy!")

fun getTaskList(): InputStream =
  ClassLoader.getSystemResourceAsStream("todo.txt") ?: error("Not found")

val tasks = sequence {
  val reader = getTaskList().bufferedReader()
  try {
    while (true) {
      val task = withContext(Dispatchers.IO) { // error!
        reader.readLine()
      }
      if (task != null) yield(task) else break
    }
  } finally {
    println("Closing the file…")
    reader.close()
  }
}

fun main() {
  for (task in tasks) {
    println("$task. " + hype.random())

    if (task.contains("party")) {
      error("Can't do any more tasks, it's party time!")
    }
  }
}
