package com.example.todo

import java.io.*
import kotlinx.coroutines.*
import kotlinx.coroutines.flow.*

val hype = listOf("You got this!", "Crush it!", "Let's go!", "Easy!")

fun getTaskList(): InputStream =
  ClassLoader.getSystemResourceAsStream("todo.txt") ?: error("Not found")

val tasks = flow {
  val reader = getTaskList().bufferedReader()
  try {
    while (true) {
      val task = withContext(Dispatchers.IO) {
        reader.readLine()
      }
      if (task != null) emit(task) else break
    }
  } finally {
    println("Closing the file…")
    reader.close()
  }
}

suspend fun main() {
  tasks.collect { task ->
    println("$task. " + hype.random())

    if (task.contains("party")) {
      error("Can't do any more tasks, it's party time!")
    }
  }
}
